/*
 * $Id: cgiupl.h,v 1.6 1998/05/30 08:46:59 root Exp $
 *
 * Based on code written by an anonymous software socialist.
 * 
 * modified for use in CGI's by James Bourne <jbourne@hardrock.org>
 * May 9, 1998.  See the file COPYING for more information on Copyright
 *   
 *   Copyright (C) 1998  James Bourne <jbourne@hardrock.org>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _CGIUPL_H
#define _CGIUPL_H

typedef struct {
	char *name;
	char *val;
	int type;
} dentry;

#define PATH_MAX			256

#define part_read_OK		0
#define part_read_EOF	-1
#define part_read_EOP	-2
#define part_read_FAIL	-3
#define part_gets_OK		0
#define part_gets_EOF	-4
#define part_gets_FAIL	-5
#define PARSE_OK			0
#define BOUNDGET_FAIL	-6		/* Error getting boundry declaration */
#define BOUNDPRS_FAIL	-7		/* Error parsing boundry declaration */
#define DISPPARSE_FAIL	-8		/* Error parsing Content-Disposition */
#define DISPGET_FAIL		-9		/* Error getting the dispostition line */
#define DISPNEXT_FAIL	-10	/* Error getting line after disposition line */
#define FVALUE_FAIL		-11	/* Error getting field value */
#define VALPART_FAIL		-12	/* Error getting partition after value */
#define NULLFILE_FAIL	-13	/* Error getting null line for empty file */
#define NNULLFILE_FAIL	-14	/* Error getting null line for nonempty file */
#define ENCTYPE_FAIL		-15	/* Form ENCTYPE is not multipart/form-data */

#define TYPE_FILE	0
#define TYPE_DATA	1
#define TYPE_EMPTYFILE	2

#ifdef CGIUPL
long contentLength = 0;
long bytesRead = 0;
#else
extern long contentLength;
extern long bytesRead;
#endif

char cgiUploadDir[PATH_MAX+1];

int DecodeStdin (dentry *);
char *check_dserror(int);
#endif
